<?php
/**
 * Created by PhpStorm.
 * User: leonardooliveira
 * Date: 16/09/14
 * Time: 16:08
 */

namespace Financeiro\Logic\ControleBancario\ImplantacaoSaldo;

use Financeiro\Entities\Sdoccorr;
use Financeiro\Logic\AtualizaFluxodeCaixa\FluxodeCaixa;
use Geral\Util\DateUtil;
use Geral\Util\Ambiente;
use Setforms2\Shared\Registry;
class ImplantacaoSaldo {
    public static function atualizaSaldoImplantacao($nrorg, $cdreducont, $dtsdoccorr, $valor){
        try {
            $dtsdoccorr = self::formataData($dtsdoccorr);
            /** @var $sdoccorr Sdoccorr */
            $sdoccorr = Sdoccorr::findOneByNrorgAndCdreducontAndDtsdoccorr($nrorg, $cdreducont, $dtsdoccorr);

            if (!$sdoccorr) {
                self::insereSaldo($cdreducont, $dtsdoccorr, $valor);
                $valorEvoluido = $valor;
            } elseif (!$sdoccorr->getVrsdoimpla()) {
                $valorEvoluido = -$sdoccorr->getVrsdoccorr() + $valor;
                $sdoccorr->setVrsdoimpla($valor);
                $sdoccorr->setVrsdoccorr($valor);
            } else{
                throw new \Exception('Implantação do saldo de conta corrente já cadastrado!');
            }

            FluxodeCaixa::evoluiSaldoImplantacao($cdreducont, $dtsdoccorr, $nrorg, $valorEvoluido);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    private static function insereSaldo($cdreducont, $dtsdoccorr, $saldo){
        try {
            $novosaldo = new Sdoccorr();
            $novosaldo->setNrorg(Ambiente::getNrorg());
            $novosaldo->setDtinclusao(DateUtil::getDataAtual());
            $novosaldo->setCdreducont($cdreducont);
            $novosaldo->setDtsdoccorr($dtsdoccorr);
            $novosaldo->setVrsdoccorr($saldo);
            $novosaldo->setVrsdoimpla($saldo);
            $novosaldo->persist();

            Registry::getEntityManager()->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    private static function formataData($data){
        if(strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDatadeString($data);
        $data = DateUtil::truncateData($data);

        return $data;
    }

} 