<?php
/**
 * Created by JetBrains PhpStorm.
 * User: geovanesantos
 * Date: 01/07/14
 * Time: 12:50
 * To change this template use File | Settings | File Templates.
 */

namespace Scheduler\Facade;

require_once __DIR__ . '/../Util/Macros.php';

class SchedulerWizardConfirmaBuilder {
    //Constrói Tela de Confirmação
    public static function buildConfirma(){

        $allFields=tk_get_all_fields();
        unset($allFields['_ID']);
        unset($allFields['_STATE']);
        unset($allFields['_CHECKED']);
        unset($allFields["scd_Agen_ExpAgendada"]);
        \Scheduler\Util\Macros::tk_set_invisible_fields($allFields);

        $process = new \Scheduler\Logic\ProcessQueue; //representa um objeto de processo

//        $procIniFields=Array("Nome", "Tipo", "Desc");
//        foreach ($procIniFields as $field){
//
//            $value=tk_get_context_vars("scd_Agen_$field", "scd_Agen_ProcIni");
//            tk_set_field_value("scd_$field"."_Proc", $value);
//            tk_set_visible_field("scd_$field"."_Proc");
//        }
        // Para cada propriedade, preenche o campo, deixa visível e coloca o valor no objeto ProcessQueue
        $nome=tk_get_context_vars("scd_Agen_Nome", "scd_Agen_ProcIni");
        tk_set_field_value("scd_Nome_Proc", $nome);
        tk_set_visible_field("scd_Nome_Proc");
        $process->setName($nome);
        
        $tipo=tk_get_context_vars("scd_Agen_Tipo", "scd_Agen_ProcIni");
        tk_set_field_value("scd_Tipo_Proc", $tipo);
        tk_set_visible_field("scd_Tipo_Proc");
        $process->setType($tipo);

        $desc=tk_get_context_vars("scd_Agen_Desc", "scd_Agen_ProcIni");
        tk_set_field_value("scd_Desc_Proc", $desc);
        tk_set_visible_field("scd_Desc_Proc");
        $process->setDesc($desc);

        //pega cada um dos parâmetros preenchidos e coloca num array nome[valor], com o qual ProcessQueue sabe lidar
        $activeParams=tk_get_env_var("ACTIVE_FIELDS_WIZARD");
        $paramsValues=Array();  //o array nome[valor]
        foreach($activeParams as $param){

//            $paramsValues[$param]
            $currentParamValue=tk_get_context_vars($param, "scd_Agen_ProcParams"); //separa o valor do param pra facilitar o uso

            tk_set_field_value($param,$currentParamValue); //seta o valor do campo para o determinado nos params
            tk_set_visible_field($param);                     //deixa o campo visível

            //se for PROCEDURE_NAME, precisa mostrar o nome real da procedure também

//            if($param==="PROCEDURE_NAME"){
//                tk_set_visible_field("PROCEDURE_DB_NAME");
//                tk_set_field_value("PROCEDURE_DB_NAME",$currentParamValue);
//            }

            if($param==="PARAMETERS"){ //se for PARAMETERS, precisa quebrar as atribuições em diferentes parâmetros

                $paramFieldArray=explode("\n",$currentParamValue); //explode em EOL, cada linha é um parametro
                foreach($paramFieldArray as $attribParam){  //separa a atribuição
                    $paramAttrib=explode("=", $attribParam);  //explode no = , [0] é nome, [1] é valor
                    $paramName=$paramAttrib[0];
                    $paramValue=$paramAttrib[1];
                    $paramsValues[$paramName]=$paramValue;  //coloca no array que vai para o ProcessQueue
                }
            }
            else{//se não, é só colocar o parâmetro no array
                $paramsValues[$param]=tk_get_context_vars($param, "scd_Agen_ProcParams");
            }
        }

        $array_attribs=tk_get_env_var("ATTRIBUTED_PARAMETERS_WIZARD"); //pega os parâmetros pré-atribuidos
        $paramsValues=array_merge($paramsValues,$array_attribs);  //junta os dois arrays
        $process->setParameters($paramsValues);   //seta os parâmetros do objeto

        $status=tk_get_context_vars("scd_Agen_Status", "scd_Agen_ProcMode");
        tk_set_field_value("scd_Status_Proc_Mode", $status);
        tk_set_visible_field("scd_Status_Proc_Mode");
        $process->setStatus($status);

        if ($status==="AGENDADO"){ //se o status é agendado, mostra a frequência

            $fields=tk_get_env_var("agen_ExpAgendada");
            $process->setSchedule($fields);

            //Mudar
//            $expressao=implode(" ", $fields);

            tk_set_visible_fieldgroup("scd_Agendamento");
            tk_set_field_value("scd_Agen_ExpAgendada",self::returnExp($fields));

            tk_set_invisible_field("scd_Priority_Proc_Mode");

        }
        else{ // se não, mostra a prioridade
            tk_set_invisible_fieldgroup("scd_Agendamento");

            tk_set_visible_field("scd_Priority_Proc_Mode");
            $priority=tk_get_context_vars("scd_Agen_Priority", "scd_Agen_ProcMode");
            $process->setPriority($priority);

            tk_set_field_value("scd_Priority_Proc_Mode", $priority);
        }
        tk_set_env_var("Processo", $process);
    }

    public static function returnExp($arrayCron){ //transforma o cron em algo mais legível
        $expression=implode(" ", $arrayCron);
        $result = $expression;

        $matchMonthly="/^(H|[0-5]?[0-9]) (H|([0-1]?[0-9]|2[0-3])) (H|([1-2][0-9]|0?[1-9]|3[0-1])) \* \*$/";
        $matchWeekly="/^(H|[0-5]?[0-9]) (H|([0-1]?[0-9]|2[0-3])) \* \* (H|[0-7])$/";
        $matchDaily="/^(H|[0-5]?[0-9]) (H|([0-1]?[0-9]|2[0-3])) \* \* \*$/";
        $matchHourly="/^(H|[0-5]?[0-9]) \* \* \* \*$/";

        if (preg_match($matchMonthly,$expression)){
            $result="Mensalmente, a cada dia $arrayCron[2], às $arrayCron[1] hora(s)";
            if ($arrayCron[0]!=='H'&&$arrayCron[0]!='0'){
                $result.=" e $arrayCron[0] minuto(s)";
            }
        }
        if (preg_match($matchWeekly,$expression)){
            $result="Semanalmente, toda(o) ".self::diaSemana($arrayCron[4]).", às $arrayCron[1] hora(s)";
            if ($arrayCron[0]!=='H'&&$arrayCron[0]!='0'){
                $result.=" e $arrayCron[0] minuto(s)";
            }
        }
        if (preg_match($matchDaily,$expression)){
            $result="Diariamente às $arrayCron[1] hora(s)";
            if ($arrayCron[0]!=='H'&&$arrayCron[0]!='0'){
                $result.=" e $arrayCron[0] minuto(s)";
            }
        }
        if (preg_match($matchHourly,$expression)){
            $result="De hora em hora";
            if ($arrayCron[0]!=='H'&&$arrayCron[0]!='0'){
                $result.=", no minuto $arrayCron[0]";
            }
        }
//        tk_warning("Retorno: ".$expression);
        return $result;
    }

    public static function diaSemana($dia){
        switch($dia){
            case 0:
                return "Domingo";
                break;
            case 1:
                return "Segunda-Feira";
                break;
            case 2:
                return "Terça-Feira";
                break;
            case 3:
                return "Quarta-Feira";
                break;
            case 4:
                return "Quinta-Feira";
                break;
            case 5:
                return "Sexta-Feira";
                break;
            case 6:
                return "Sábado";
                break;
            default:
                return "Domingo";
                break;
        }
    }
}