/* Sistemas Integrados TEKNISA
Nome: 0100_LSGSTPO_GERA_NF_ONBOS.SQL

@C:\web_550\sql\end_conv\oracle\clientes\lsg\0100_LSGSTPO_GERA_NF_ONBOS.SQL

Descrio:
Rotina para gerao de notas fiscais a partir de tabelas temporrias

raise_application_error(-20501, '' , True);

Criao:
15/03/2012 - Jefferson de Melo Gouvea
*/

CREATE OR REPLACE PROCEDURE GERA_NF_ONBOS
(
	P_CDPIDSEQ       IN TMP_ING_ONBOSTEKNF.CDPIDSEQ%TYPE)
AS
   V_CDINSCESTA				VARCHAR2(16);
   V_CDINSCMUNI				VARCHAR2(16);
   V_NRLANCTONF				VARCHAR2(20);
   V_CDFILIMOVI      		VARCHAR2(04);
   V_CDPRODUTO					VARCHAR2(20);
   V_NRSEQITPROD				VARCHAR2(04);
   V_DSPRODEMIS				VARCHAR2(50);
   V_NRLANCESTQ				VARCHAR2(20);
   V_CDFORNECED				VARCHAR2(21);
   V_CDCLIENTE					VARCHAR2(21);
   V_IDTPIJURNF				VARCHAR2(01);
   V_CDSERIE					VARCHAR2(05);
   V_IDORIGDESTNF				VARCHAR2(01);
   V_CDEMPRESA					VARCHAR2(02);
   V_IDTPLANCDESC				VARCHAR2(01);
   V_NRINSJURNF				VARCHAR2(16);
   V_VRDESCITEM				NUMBER;
   V_VRDESPERITEM				NUMBER;
   V_VRPRODUTOS				NUMBER;
   V_VRNOTAFISC				NUMBER;
   /* Variveis para log de erros */
   V_EXISTE						VARCHAR2(20);
   V_EITEM						VARCHAR2(01);
   V_NFLOG						VARCHAR2(1000);
   V_PRODLOG					VARCHAR2(1000);
   V_DSERRO						VARCHAR2(2000);
   V_CDNVPRODUTO				VARCHAR2(01);
   V_IDGERAVENC				VARCHAR2(01);
   V_NRITEM						NUMBER;
   V_IDCTRLESTQ				VARCHAR2(01);
   V_COUNTNF					NUMBER;
   V_COUNTIRREG				NUMBER;
   V_CLIENT_INFO				VARCHAR2(64);
   V_CDOPERADOR				VARCHAR2(12);
   V_CDTIPOOPER				VARCHAR2(02);
   V_CDARVPROD					VARCHAR2(20);
   V_PRIPROD					VARCHAR2(01);

   V_SUMENCARGO            FLOAT;
   V_IDPRODATIV            VARCHAR2(01);

   V_RESULT_DADOS_FIN      VARCHAR2(50);
   V_DADOADIC              VARCHAR2(03);
BEGIN
   /* Parametro para verificar apenas produto de nvel completo */

   V_NFLOG := NULL;
   SELECT MAX(CDNVPRODUTO)
     INTO V_CDNVPRODUTO
     FROM PRODUTO;
   V_CLIENT_INFO := '';
   V_CDOPERADOR  := '';
	/* Retorna o codigo e o nome do operador */
   DBMS_APPLICATION_INFO.READ_CLIENT_INFO(V_CLIENT_INFO);
   V_CDOPERADOR := SUBSTR(V_CLIENT_INFO,1,12);
	/* Busca as notas fiscais ainda no importada */
   FOR C_NF IN (SELECT CDPIDSEQ, CDFILIORIG, CDFILIDEST, CLIEFISICO, CLIEJURIDI, CLIEPADRAO,
                       DADOSADDNF, CDSERIEBOS, NRNOTABOS, DTSAIDABOS,
                       DTEMISSBOS, CDCHAVACES, IDSITUNF, CDBARSET, IDIMPCANCINTEGRA
                  FROM TMP_ING_ONBOSTEKNF
                 WHERE CDPIDSEQ = P_CDPIDSEQ) LOOP
 		/* Busca a Data de Processamento da Filial */
      BEGIN
         SELECT NVL(IDCTRLESTQ, 'S')
           INTO V_IDCTRLESTQ
           FROM PARAMFILIAL
          WHERE CDFILIAL = C_NF.CDFILIORIG;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDCTRLESTQ := 'S';
      END;
      /* Verifica tipo de Operao */
      BEGIN
       	SELECT USR_CDTPOPONBOS
           INTO V_CDTIPOOPER
			  FROM PARAMGERAL;
      EXCEPTION
   	  	WHEN NO_DATA_FOUND THEN
           	V_CDTIPOOPER := NULL;
      END;
      IF V_CDTIPOOPER IS NULL THEN
         V_NFLOG := V_NFLOG||'Tipo de operao '||V_CDTIPOOPER||' para gerao de nota fiscal no cadastrado.*';
      END IF;
   	/* Rotina para verificar se a filial da nota fiscal controla estoque */
      BEGIN
         SELECT NVL(IDATUESTTPOP, V_IDCTRLESTQ)
           INTO V_IDCTRLESTQ
           FROM TIPOOPERAC
          WHERE IDENTRSAIDOP = 'S'
            AND CDTIPOOPER   = V_CDTIPOOPER;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_IDCTRLESTQ := V_IDCTRLESTQ;
      END;
      /* Verifica empresa, inscrio municipal e estadual */
      BEGIN
      	SELECT MAX(F.CDEMPRESA), MAX(NVL(E.CDINSCESTA,F.CDINSCESTA)), MAX(NVL(E.CDINSCMUNI,F.CDINSCMUNI))
           INTO V_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI
           FROM SERIENF S, FILIAL F, EMPRCNTRFIL E
			 WHERE (S.CDEMPRESA  = F.CDEMPRESA)  	 AND
			       (S.CDINSCESTA = F.CDINSCESTA) 	 AND
			       (S.CDINSCMUNI = F.CDINSCMUNI) 	 AND
			       (S.CDSERIE	   = C_NF.CDSERIEBOS) AND
			       (F.CDFILIAL	= C_NF.CDFILIORIG) AND
                (F.CDFILIAL	= E.CDFILIAL(+))   AND
                (F.CDEMPRESA  = E.CDEMPRESA(+))
			 ORDER BY S.CDSERIE;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
       	   V_CDEMPRESA  := NULL;
            V_CDINSCESTA := NULL;
            V_CDINSCMUNI := NULL;
      END;
      /* Verifica possibilidade de NF duplicada */
      BEGIN
         SELECT COUNT(1)
           INTO V_COUNTNF
           FROM NOTAFISCAL
          WHERE NRACESSONFE = C_NF.CDCHAVACES;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNTNF := 0;
      END;
      IF (V_COUNTNF <> 0) THEN
         V_NFLOG := V_NFLOG||'Nota fiscal j cadastrada. Chave de acesso: '||C_NF.CDCHAVACES||'.*';
      END IF;
    	/* Verifica Inscrio Juridica */
      BEGIN
         SELECT MAX(I.NRINSJURCLIE)
           INTO V_NRINSJURNF
           FROM (SELECT NRINSJURCLIE
					    FROM FILIAL, CLIENTE
					   WHERE USR_CDCLIECATER = NRINSJURCLIE
                    AND CDFILIAL 		 = C_NF.CDFILIDEST) I;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NRINSJURNF := NULL;
      END;
      IF V_NRINSJURNF IS NULL THEN
         V_NFLOG := V_NFLOG||'CPF ou CNPJ no relacionado no sistema Teknisa.*';
      END IF;
      IF (V_COUNTNF = 0) AND (V_NFLOG IS NULL) THEN
         /* Rotina de Importao da Nota Fiscal */
			V_CDFORNECED   := NULL;
         V_CDCLIENTE    := NULL;
         V_IDTPIJURNF   := NULL;
         V_CDSERIE      := NULL;
         NOVO_CODIGO('LANCNF/FILIAL' || C_NF.CDFILIORIG, V_NRLANCTONF);
         V_NRLANCTONF := SUBSTR(V_NRLANCTONF, 11, 10);

         IF V_IDCTRLESTQ = 'S' THEN
            NOVO_CODIGO('LANCTOEST' || C_NF.CDFILIORIG, V_NRLANCESTQ);
            V_NRLANCESTQ := SUBSTR(V_NRLANCESTQ, 11, 10);
         END IF;

         SELECT NVL(IDORIGDESTOP,'C')
           INTO V_IDORIGDESTNF
           FROM TIPOOPERAC
          WHERE IDENTRSAIDOP = 'S'
            AND CDTIPOOPER   = V_CDTIPOOPER;

         IF V_IDORIGDESTNF = 'L' THEN
         	SELECT MAX(IDTPIJURFILI)
              INTO V_IDTPIJURNF
              FROM FILIAL
             WHERE CDFILIAL = C_NF.CDFILIORIG;
         ELSE
            SELECT MAX(CDCLIENTE), MAX(IDTPIJURCLIE)
              INTO V_CDCLIENTE, V_IDTPIJURNF
              FROM CLIENTE
             WHERE NRINSJURCLIE = V_NRINSJURNF;
         END IF;

         V_CDSERIE   := C_NF.CDSERIEBOS;

         INSERT INTO NOTAFISCAL
             (CDFILIAL,     NRLANCTONF,        CDEMPRESA,     CDINSCESTA,
              CDINSCMUNI,   CDFILIEMIT,        CDFILIRECE,    NRINSJURNF,
              IDBLOQUEADO,  IDDOCFISCAL,       IDDOCFINANC,   DTENTRSAID,
              VRPRODUTOS,   VRNOTAFISC,        IDENTRSAIDOP,  CDTIPOOPER,
              CDSERIE,      IDDOCCONTAB,       IDSTATUS,      IDDOCFISCENT,
              CDMODDOCFISC, DTEMISSAO,
              CDFORNECED,   CDCLIENTE,         IDTPIJURNF,    NRNOTAFISC,
              CDSERIEENTR,  IDSISTEMA,         IDORIGDESTNF,  NRACESSONFE, IDTIPOEMISNFE,
              NRNOTAFISCALELE, USR_CDBARSET, IDIMPCANCINTEGRA)
         VALUES
              (C_NF.CDFILIORIG,   V_NRLANCTONF,      V_CDEMPRESA,     	V_CDINSCESTA,
               V_CDINSCMUNI,      C_NF.CDFILIORIG,	  NULL,   				V_NRINSJURNF,
               'N',               'S',               'S',               TRUNC(C_NF.DTSAIDABOS),
               0,                 0,                 'S', 					V_CDTIPOOPER,
               V_CDSERIE,         'S',               'P', 					'N',
               NULL, 				 TRUNC(C_NF.DTEMISSBOS),
               V_CDFORNECED,      V_CDCLIENTE,       V_IDTPIJURNF,      C_NF.NRNOTABOS,
               NULL,     			 'DFS',       		  V_IDORIGDESTNF, 	C_NF.CDCHAVACES, '1',
               SUBSTR(LPAD(C_NF.NRNOTABOS, 20, '0'),12,9), C_NF.CDBARSET, C_NF.IDIMPCANCINTEGRA);

			/* Rotina de Importao dos Itens da Nota */
         V_VRPRODUTOS := 0;
         V_VRNOTAFISC := 0;
         V_NRSEQITPROD := '0001';
         V_EITEM := '0';

         V_PRODLOG := NULL;
         FOR C_ITEM IN (SELECT CDPIDSEQ, CDSEQITEM, CDPRODUTO, CDPRODEMIS,
                               (NVL(QTDEPRODBOS,0)) AS QTDEPRODBOS,
                               (NVL(VRUNITBOS,0)) AS VRUNITBOS,
                               (NVL(VRUNITBOS,0)*NVL(QTDEPRODBOS,0)) AS VRTOTAITEM
          					  FROM TMP_ING_ONBOSTEKIT
          					 WHERE CDPIDSEQ = C_NF.CDPIDSEQ
                         ORDER BY CDSEQITEM) LOOP
				/* Rotina de verificao de inconsistncias */
            /* Valida Produto */
            BEGIN
            	SELECT CDARVPROD
                 INTO V_CDARVPROD
                 FROM PRODUTO
                WHERE CDPRODUTO = C_ITEM.CDPRODUTO
                	AND CDNVPRODUTO = V_CDNVPRODUTO;
            EXCEPTION
            	WHEN NO_DATA_FOUND THEN
               	V_EXISTE := NULL;
            END;
				IF V_CDARVPROD IS NULL THEN
             	V_PRODLOG := V_PRODLOG||'Produto '||C_ITEM.CDPRODUTO||' no cadastrado.*';
            END IF;


            /* Valida se o produto esta ativo para a filial */
            BEGIN
               SELECT IDPRODATIV
                 INTO V_IDPRODATIV
                 FROM PRODFILI
                WHERE CDFILIAL = V_CDFILIMOVI
                  AND CDPRODUTO = C_ITEM.CDPRODUTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_IDPRODATIV := 'S';
            END;

            IF V_IDPRODATIV = 'N' THEN
               V_PRODLOG := V_PRODLOG||'Produto '||C_ITEM.CDPRODUTO||' inativo para a filial.*';
            END IF;

            /* Valida se o produto esta ativo */
            BEGIN
               SELECT IDPRODATIVPR
                 INTO V_IDPRODATIV
                 FROM PRODUTO
                WHERE CDPRODUTO = C_ITEM.CDPRODUTO;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_IDPRODATIV := 'S';
            END;

            IF V_IDPRODATIV = 'N' THEN
               V_PRODLOG := V_PRODLOG||'Produto '||C_ITEM.CDPRODUTO||' encontra-se inativo.*';
            END IF;

            IF V_PRODLOG IS NOT NULL THEN
             	V_EITEM := '1';
            ELSE
             	/* Importao dos Itens da Nota */
               V_CDFILIMOVI := C_NF.CDFILIORIG;
               SELECT MAX(CDARVPROD), MAX(NMPRODUTO)
                 INTO V_CDPRODUTO, V_DSPRODEMIS
                 FROM PRODUTO
                WHERE CDPRODUTO = C_ITEM.CDPRODUTO;
               SELECT NVL(IDTPLANCDESC,'V')
                 INTO V_IDTPLANCDESC
                 FROM PARAMGERAL;

             	V_VRDESCITEM := 0;
              	V_VRDESPERITEM := 0;

               INSERT INTO ITEMPRODUTO
                    (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,
                		CDPRODEMIS,   DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,
                     VRUNITITEM,   VRDESCITEM,   VRTOTAITEM,   VRCONTITEM,
                     IDCONFORITEM, VRBRUTITEM,   VRDESPERITEM, CDFILIMOVI,
                     CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                     CDMARCA)
               VALUES
                    (C_NF.CDFILIORIG,   V_NRLANCTONF,      V_NRSEQITPROD,  C_ITEM.CDPRODUTO,
                     C_ITEM.CDPRODEMIS,  V_DSPRODEMIS,      'S',            C_ITEM.QTDEPRODBOS,
                     C_ITEM.VRUNITBOS, V_VRDESCITEM, C_ITEM.VRTOTAITEM, C_ITEM.VRTOTAITEM,
                     'S', C_ITEM.VRTOTAITEM, V_VRDESPERITEM, V_CDFILIMOVI,
                     ' ',    ' ',  ' ', ' ',
                     '99999');

               V_VRPRODUTOS  := V_VRPRODUTOS + C_ITEM.VRTOTAITEM;
               V_VRNOTAFISC  := V_VRNOTAFISC + C_ITEM.VRTOTAITEM - V_VRDESCITEM;
               V_NRSEQITPROD := LPAD((TO_NUMBER(V_NRSEQITPROD) + 1), 4, 0);
            END IF;
         END LOOP;

         /* INSERE TODOS OS ENCARGOS QUE NO POSSUEM NA NOTA FISCAL COM O VALOR IGUAL A ZERO (0) */
         INSERT INTO ITEMENCARGO
            (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
            (SELECT C_NF.CDFILIORIG, V_NRLANCTONF, CDENCARGO, 0
               FROM ENCARGO
              WHERE NOT EXISTS(SELECT CDENCARGO
                                 FROM ITEMENCARGO
                                WHERE CDFILIAL = C_NF.CDFILIORIG
                                  AND NRLANCTONF = V_NRLANCTONF
                                  AND CDENCARGO = ENCARGO.CDENCARGO));

         BEGIN
            SELECT SUM(NVL(VRDESCBOS,0))
              INTO V_SUMENCARGO
       		  FROM TMP_ING_ONBOSTEKIT
          	 WHERE CDPIDSEQ = C_NF.CDPIDSEQ;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_SUMENCARGO := 0;
         END;

         UPDATE ITEMENCARGO
            SET VRITEMENCA = V_SUMENCARGO
          WHERE CDFILIAL = C_NF.CDFILIORIG
            AND NRLANCTONF = V_NRLANCTONF
            AND CDENCARGO = '02';

			/* Se houver erro na importao de algum produto, deleta a nota e os itens importados */
         IF V_EITEM = '0' THEN
          	BEGIN
            	SELECT COUNT(1)
                 INTO V_NRITEM
                 FROM ITEMPRODUTO
                WHERE CDFILIAL = C_NF.CDFILIORIG
                  AND NRLANCTONF = V_NRLANCTONF;
            EXCEPTION
            	WHEN NO_DATA_FOUND THEN
               	V_NRITEM := NULL;
            END;
            IF (V_NRITEM = 0 OR (V_NRITEM IS NULL)) THEN
             	V_EITEM := '1';
             	IF V_NFLOG IS NULL THEN
                	V_NFLOG := '';
               END IF;
            END IF;
            /* Rotina de Gerao dos Impostos da Nota Fiscal */
            IF ((V_NFLOG IS NULL) AND (V_EITEM = '0')) THEN
					/* Gera os impostos, contas a receber e atualiza o estoque para notas de entrada */
               IMPOSTO_SAIDA(V_CDEMPRESA, V_CDINSCESTA, V_CDTIPOOPER, V_CDCLIENTE,
                             C_NF.CDFILIORIG,  V_NRLANCTONF, C_NF.DTSAIDABOS, V_VRNOTAFISC,
                             V_NRLANCESTQ);
               UPDATE NOTAFISCAL
                  SET VRNOTAFISC = V_VRNOTAFISC
                WHERE CDFILIAL   = C_NF.CDFILIORIG
                  AND NRLANCTONF = V_NRLANCTONF;
 	            V_CDFILIMOVI  := C_NF.CDFILIORIG;
               IF V_IDCTRLESTQ = 'S' THEN
	               ATUALIZA_ESTOQUE(C_NF.CDFILIORIG, C_NF.DTSAIDABOS, C_NF.DTSAIDABOS, C_NF.CDFILIORIG, V_NRLANCESTQ);
                  SELECT COUNT(1)
                    INTO V_COUNTIRREG
                    FROM MOVILOTE M, PRODFILI F, TMP_ING_ONBOSTEKIT S
                   WHERE (M.NRMOVILOTE = C_NF.CDFILIORIG||V_NRLANCESTQ)
                     AND (M.CDFILIAL   = V_CDFILIMOVI)
                     AND (M.CDPRODUTO  = F.CDPRODUTO(+))
                     AND (M.CDFILIAL   = F.CDFILIAL(+))
                     AND (S.CDPIDSEQ	= C_NF.CDPIDSEQ)
                     AND (S.CDPRODUTO  = M.CDPRODUTO)
                     AND (NVL(M.CDALMOXARIFE,' ') = ' ')
                     AND (NVL(M.CDLOCALESTOQ,' ') = ' ')
                     AND (NVL(F.IDCNTRESTOQ, 'S') = 'S');
                  IF V_COUNTIRREG > 0 THEN
							V_PRIPROD := '0';
                     FOR C_IRR IN(SELECT DISTINCT NVL(P.CDARVPROD,'') AS PRODUTO
                                      FROM MOVILOTE M, PRODUTO P, PRODFILI F, TMP_ING_ONBOSTEKIT S
                                     WHERE (NRMOVILOTE  = C_NF.CDFILIORIG||V_NRLANCESTQ)
                                       AND (M.CDFILIAL  = V_CDFILIMOVI)
                                       AND (M.CDPRODUTO = F.CDPRODUTO)
                                       AND (M.CDFILIAL  = F.CDFILIAL(+))
                                       AND (M.CDPRODUTO = P.CDPRODUTO(+))
                                       AND (S.CDPIDSEQ  = C_NF.CDPIDSEQ)
                                       AND (S.CDPRODUTO = P.CDPRODUTO)
                                       AND (NVL(M.CDALMOXARIFE,' ') = ' ')
                                       AND (NVL(M.CDLOCALESTOQ,' ') = ' ')
                                       AND (NVL(F.IDCNTRESTOQ, 'S') = 'S')) LOOP
                  		IF V_PRIPROD = '1' THEN
                           V_PRODLOG := V_PRODLOG||', '||C_IRR.PRODUTO;
                        END IF;
                  		IF V_PRIPROD = '0' THEN
                       		V_PRODLOG := V_PRODLOG||'Lanamento do(s) produto(s) '||C_IRR.PRODUTO;
                        	V_PRIPROD := '1';
                        END IF;
                     END LOOP;
                     V_PRODLOG := V_PRODLOG||' geraria(m) irregularidade(s) no estoque.*';
                     DELETA_NF(C_NF.CDFILIORIG, V_NRLANCTONF);
                     ATUALIZA_ESTOQUE(V_CDFILIMOVI, C_NF.DTSAIDABOS, C_NF.DTSAIDABOS, C_NF.CDFILIORIG, V_NRLANCESTQ);
                  END IF;
               END IF;
            END IF;
         END IF;
         UPDATE LANCTOESTOQ
            SET CDOPERADOR = V_CDOPERADOR
          WHERE CDFILIAL   = C_NF.CDFILIORIG
            AND NRLANCESTQ = V_NRLANCESTQ;
         IF (V_NFLOG IS NULL) AND (V_PRODLOG IS NULL) THEN
            BEGIN
            	SELECT COUNT(1)
                 INTO V_EXISTE
                 FROM NOTAFISCAL
                WHERE CDFILIAL   = C_NF.CDFILIORIG
                	AND NRLANCTONF = V_NRLANCTONF;
            EXCEPTION
            	WHEN NO_DATA_FOUND THEN
               	V_EXISTE := 0;
            END;
         	IF V_EXISTE = 0 THEN
             	V_NFLOG := V_NFLOG||'Erro inesperado. Favor verificar layout do arquivo.*';
            END IF;
         END IF;

			/* Rotina de importao dos vencimentos */
         SELECT IDGERAVENC
           INTO V_IDGERAVENC
           FROM TIPOOPERAC
          WHERE CDTIPOOPER = V_CDTIPOOPER
            AND IDENTRSAIDOP = 'S';

         IF V_IDGERAVENC = 'S' THEN
            GERA_DADOS_FINANCEIRO(C_NF.CDFILIORIG,          /*   IN FILIAL.CDFILIAL%TYPE0, */
                                  V_NRLANCTONF,             /*   IN NOTAFISCAL.NRLANCTONF%TYPE,  */
                                  C_NF.CDFILIORIG,          /*   P_CDFILIPROC IN FILIAL.CDFILIAL%TYPE, */
                                  'L',                      /*   P_IDOPERACAO IN VARCHAR2,*/
                                  V_RESULT_DADOS_FIN);      /*   P_RESULTADO OUT VARCHAR2)*/
         END IF;

      END IF;
      IF NOT ((V_NFLOG IS NULL) AND (V_PRODLOG IS NULL)) THEN
      	DELETE
           FROM AUDITORIA
          WHERE CDFILIALNF = C_NF.CDFILIORIG
            AND NRLANCTONF = V_NRLANCTONF;
         DELETE
           FROM ITEMPRODUTO
          WHERE NRLANCTONF = V_NRLANCTONF
            AND CDFILIAL   = C_NF.CDFILIORIG;
         DELETE
           FROM ITEMENCARGO
          WHERE NRLANCTONF = V_NRLANCTONF
            AND CDFILIAL   = C_NF.CDFILIORIG;
         DELETE
           FROM ITEMNOTAFISC
          WHERE NRLANCTONF = V_NRLANCTONF
            AND CDFILIAL   = C_NF.CDFILIORIG;
         DELETE
           FROM NFRELACAF
          WHERE NRLANCTONF = V_NRLANCTONF
            AND CDFILIAL   = C_NF.CDFILIORIG;
         DELETE
           FROM CONTARECEBER
          WHERE NRLANCTONF = V_NRLANCTONF
            AND CDFILIAL   = C_NF.CDFILIORIG;
         DELETE
           FROM NOTAFISCAL
          WHERE NRLANCTONF = V_NRLANCTONF
            AND CDFILIAL   = C_NF.CDFILIORIG;
      END IF;
      V_DSERRO := V_NFLOG||V_PRODLOG;
      IF V_DSERRO IS NULL THEN
      	INSERT INTO DADOSIMPONBOS (CDFILIAL, NRLANCTONF, CDCLIEFISICO, CDCLIEJURIDI, CDCLIEPADRAO,
         									SGONBOS, NMCOMPAN, NRVOOBOS, IDSITUNF)
         						 VALUES (C_NF.CDFILIORIG, V_NRLANCTONF, C_NF.CLIEFISICO, C_NF.CLIEJURIDI, C_NF.CLIEPADRAO,
                            			SUBSTR(C_NF.DADOSADDNF, 1, 2), SUBSTR(C_NF.DADOSADDNF, 6, 20), SUBSTR(C_NF.DADOSADDNF, 29, 4), DECODE(NVL(C_NF.IDSITUNF,''), 'X', 'C', 'E'));


         -- MAIOR REGISTRO DA TABELA DE DADOS ADICIONAIS
         SELECT MAX(NRDADOADIC)
           INTO V_DADOADIC
           FROM DADOSADIC
          WHERE CDFILIAL = C_NF.CDFILIORIG
            AND NRLANCTONF = V_NRLANCTONF;

         IF (V_DADOADIC IS NULL) THEN
            V_DADOADIC := '001';
         ELSE
            V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);
         END IF;

         INSERT INTO DADOSADIC 	  (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
         					VALUES 	  (C_NF.CDFILIORIG, V_NRLANCTONF, V_DADOADIC, C_NF.DADOSADDNF);

         V_DADOADIC := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_DADOADIC) + 1)),3,0);

         INSERT INTO DADOSADIC 	  (CDFILIAL, NRLANCTONF, NRDADOADIC, DSDADOADIC)
         					VALUES 	  (C_NF.CDFILIORIG, V_NRLANCTONF, V_DADOADIC, C_NF.CDBARSET);
      	COMMIT;
      END IF;
      IF V_DSERRO IS NOT NULL THEN
         INSERT INTO TMP_ING_ONBOSTEKLG (CDPIDSEQ, DSERRO)
         								VALUES (C_NF.CDPIDSEQ, V_DSERRO);
         COMMIT;
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_NF_ONBOS','5.50.XXX'); END;
/
